diff --git a/test/validation/.gitignore b/test/validation/.gitignore
index 05a7424..4bbcea3 100644
--- a/test/validation/.gitignore
+++ b/test/validation/.gitignore
@@ -1,10 +1,10 @@
 *.log
 *.trs
+odp_ver_abt_log_dbg
 odp_buffer
 odp_classification
 odp_cpumask
 odp_crypto
-odp_errno
 odp_init
 odp_init_abort
 odp_init_log
@@ -16,7 +16,6 @@ odp_random
 odp_scheduler
 odp_shared_memory
 odp_synchronizers
-odp_system
 odp_time
 odp_timer
 odp_thread
diff --git a/test/validation/Makefile.am b/test/validation/Makefile.am
index 36b0ba8..dd32c39 100644
--- a/test/validation/Makefile.am
+++ b/test/validation/Makefile.am
@@ -18,12 +18,11 @@ EXECUTABLES = odp_buffer \
 	      odp_random \
 	      odp_scheduler \
 	      odp_shared_memory \
-	      odp_system \
 	      odp_synchronizers \
 	      odp_time \
 	      odp_timer \
-	      odp_errno \
-	      odp_thread
+	      odp_thread \
+	      odp_ver_abt_log_dbg
 
 COMPILE_ONLY = odp_packet_io
 
@@ -55,13 +54,15 @@ dist_odp_queue_SOURCES	= odp_queue.c $(ODP_CU_COMMON)
 dist_odp_random_SOURCES = odp_random.c $(ODP_CU_COMMON)
 dist_odp_scheduler_SOURCES = odp_scheduler.c $(ODP_CU_COMMON)
 dist_odp_shared_memory_SOURCES	= odp_shared_memory.c $(ODP_CU_COMMON)
-dist_odp_system_SOURCES = odp_system.c $(ODP_CU_COMMON)
 dist_odp_synchronizers_SOURCES = odp_synchronizers.c $(ODP_CU_COMMON)
 dist_odp_time_SOURCES   = odp_time.c $(ODP_CU_COMMON)
 dist_odp_timer_SOURCES  = odp_timer.c $(ODP_CU_COMMON)
 dist_odp_packet_io_SOURCES	= odp_packet_io.c $(ODP_CU_COMMON)
 dist_odp_packet_SOURCES = odp_packet.c $(ODP_CU_COMMON)
 dist_odp_pool_SOURCES = odp_pool.c $(ODP_CU_COMMON)
-dist_odp_errno_SOURCES = odp_errno.c $(ODP_CU_COMMON)
 dist_odp_cpumask_SOURCES = odp_cpumask.c $(ODP_CU_COMMON)
 dist_odp_thread_SOURCES = odp_thread.c $(ODP_CU_COMMON)
+odp_ver_abt_log_dbg_CFLAGS = $(AM_CFLAGS) -I$(srcdir)/ver_abt_log_dbg
+dist_odp_ver_abt_log_dbg_SOURCES  = ver_abt_log_dbg/odp_system.c \
+				    ver_abt_log_dbg/odp_errno.c \
+                                    ver_abt_log_dbg/odp_ver_abt_log_dbg.c $(ODP_CU_COMMON)
diff --git a/test/validation/odp_errno.c b/test/validation/ver_abt_log_dbg/odp_errno.c
similarity index 81%
rename from test/validation/odp_errno.c
rename to test/validation/ver_abt_log_dbg/odp_errno.c
index 89b99d7..368f26e 100644
--- a/test/validation/odp_errno.c
+++ b/test/validation/ver_abt_log_dbg/odp_errno.c
@@ -21,8 +21,3 @@ CU_TestInfo test_odp_errno[] = {
 	{"sunny day", test_odp_errno_sunny_day},
 	CU_TEST_INFO_NULL,
 };
-
-CU_SuiteInfo odp_testsuites[] = {
-	{"Errno", NULL, NULL, NULL, NULL, test_odp_errno},
-	CU_SUITE_INFO_NULL,
-};
diff --git a/test/validation/ver_abt_log_dbg/odp_errno.h b/test/validation/ver_abt_log_dbg/odp_errno.h
new file mode 100644
index 0000000..80507fa
--- /dev/null
+++ b/test/validation/ver_abt_log_dbg/odp_errno.h
@@ -0,0 +1,9 @@
+/* Copyright (c) 2015, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:	BSD-3-Clause
+ */
+
+#include "odp_cunit_common.h"
+
+extern CU_TestInfo test_odp_errno[];
diff --git a/test/validation/odp_system.c b/test/validation/ver_abt_log_dbg/odp_system.c
similarity index 93%
rename from test/validation/odp_system.c
rename to test/validation/ver_abt_log_dbg/odp_system.c
index 94ee712..1a40957 100644
--- a/test/validation/odp_system.c
+++ b/test/validation/ver_abt_log_dbg/odp_system.c
@@ -92,10 +92,3 @@ CU_TestInfo test_odp_system[] = {
 	{"odp_sys_cpu_hz",  test_odp_sys_cpu_hz},
 	CU_TEST_INFO_NULL,
 };
-
-CU_SuiteInfo odp_testsuites[] = {
-		{"System Info", NULL, NULL, NULL, NULL,
-		 test_odp_system},
-		 CU_SUITE_INFO_NULL,
-};
-
diff --git a/test/validation/ver_abt_log_dbg/odp_system.h b/test/validation/ver_abt_log_dbg/odp_system.h
new file mode 100644
index 0000000..ce99bed
--- /dev/null
+++ b/test/validation/ver_abt_log_dbg/odp_system.h
@@ -0,0 +1,9 @@
+/* Copyright (c) 2015, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:	BSD-3-Clause
+ */
+
+#include "odp_cunit_common.h"
+
+extern CU_TestInfo test_odp_system[];
diff --git a/test/validation/ver_abt_log_dbg/odp_ver_abt_log_dbg.c b/test/validation/ver_abt_log_dbg/odp_ver_abt_log_dbg.c
new file mode 100644
index 0000000..39a632e
--- /dev/null
+++ b/test/validation/ver_abt_log_dbg/odp_ver_abt_log_dbg.c
@@ -0,0 +1,16 @@
+/* Copyright (c) 2015, Linaro Limited
+ * All rights reserved.
+ *
+ * SPDX-License-Identifier:	BSD-3-Clause
+ */
+
+#include <odp.h>
+#include "odp_cunit_common.h"
+#include "odp_errno.h"
+#include "odp_system.h"
+
+CU_SuiteInfo odp_testsuites[] = {
+	{"Errno",	NULL, NULL, NULL, NULL, test_odp_errno},
+	{"System Info", NULL, NULL, NULL, NULL, test_odp_system},
+	CU_SUITE_INFO_NULL,
+};